
/*

    WARNING: This file contains generated source code.
    Do not modify, unless you know what you are doing.

    mq4build.com

*/


#define NEVALTF 4
ENUM_TIMEFRAMES EvaluationTimeframes[NEVALTF] = {PERIOD_W1, PERIOD_D1, PERIOD_H4, PERIOD_H1};
#define NBUFFERS 4
double BufferEmptyValue[NBUFFERS] = {2147483647.00000000, 2147483647.00000000, 2147483647.00000000, 2147483647.00000000};
/*
    
*/

void EvaluateProgram(string symbol, ENUM_TIMEFRAMES period, datetime time, bool &long_signal, bool &short_signal) {

   static datetime Timestamp = 0;
   static int CurrentBlockLong = 0;
   static int CurrentBlockShort = 0;
   static bool bSignalBuy = false;
   static bool bSignalSell = false;

   if ( period > PERIOD_W1) {
      long_signal = false;
      short_signal = false;
      return;
      }

   int barshift = iBarShift( symbol, period, time, true);
   if ( ( period == EvaluationTimeframes[ NEVALTF-1]) && ( barshift == 1))
      bProcessingHistory = false;

   datetime bartime = iTime( symbol, period, barshift);
   if ( bartime == Timestamp) {
      long_signal = bSignalBuy;
      short_signal = bSignalSell;
      if ( long_signal) WhenSignal( symbol, period, time, OP_BUY);
      if ( short_signal) WhenSignal( symbol, period, time, OP_SELL);
      return;
      }

   bSignalBuy = false;
   bSignalSell = false;


   if ( CurrentBlockLong == 0) {
       if ( EvaluateBlock0( symbol, period, time, OP_BUY))
            CurrentBlockLong++;
      }
   if ( CurrentBlockShort == 0) {
       if ( EvaluateBlock0( symbol, period, time, OP_SELL))
            CurrentBlockShort++;
      }

   if ( CurrentBlockLong == 1) {
      if ( !EvaluateBlock0( symbol, period, time, OP_BUY)) CurrentBlockLong = 0;
      else if ( EvaluateBlock1( symbol, period, time, OP_BUY))
            CurrentBlockLong++;
      }
   if ( CurrentBlockShort == 1) {
      if ( !EvaluateBlock0( symbol, period, time, OP_SELL)) CurrentBlockShort = 0;
      else if ( EvaluateBlock1( symbol, period, time, OP_SELL))
            CurrentBlockShort++;
      }

   if ( CurrentBlockLong == 2) {
      if ( !EvaluateBlock1( symbol, period, time, OP_BUY)) CurrentBlockLong = 0;
      else if ( EvaluateBlock2( symbol, period, time, OP_BUY))
            CurrentBlockLong++;
      }
   if ( CurrentBlockShort == 2) {
      if ( !EvaluateBlock1( symbol, period, time, OP_SELL)) CurrentBlockShort = 0;
      else if ( EvaluateBlock2( symbol, period, time, OP_SELL))
            CurrentBlockShort++;
      }

   // validation trigger
   if ( CurrentBlockLong == 3) {
      if ( !EvaluateBlock2( symbol, period, time, OP_BUY)) CurrentBlockLong = 0;
         else if ( EvaluateTriggerValidationLong( symbol, period, time))
            bSignalBuy = true;
         
      }
   if ( CurrentBlockShort == 3) {
      if ( !EvaluateBlock2( symbol, period, time, OP_SELL)) CurrentBlockShort = 0;
         else if ( EvaluateTriggerValidationShort( symbol, period, time))
            bSignalSell = true;
         
      }
   Timestamp = bartime;
   long_signal = bSignalBuy;
   short_signal = bSignalSell;
   if ( long_signal) WhenSignal( symbol, period, time, OP_BUY);
   if ( short_signal) WhenSignal( symbol, period, time, OP_SELL);
   }

/*
    Weekly CCI
*/
bool EvaluateBlock0( string symbol, ENUM_TIMEFRAMES period, datetime time, int direction) {

   static datetime Timestamp = 0;
   static bool bSignalBuy = false;
   static bool bSignalSell = false;

   if ( period > PERIOD_W1) {
      return( false);
      }

   datetime bartime = iTime( symbol, period, iBarShift( symbol, period, time, true));
   if ( bartime == Timestamp) {
      if ( direction == OP_BUY) return( bSignalBuy);
      if ( direction == OP_SELL) return( bSignalSell);
      }

   if ( !bSignalBuy) {
      bSignalBuy = true;
      bSignalBuy &= EvaluateTrigger0ValidationLong( symbol, period, time);
      }
   else {
      bSignalBuy = !EvaluateTrigger0InvalidationLong( symbol, period, time);
      }

   if ( !bSignalSell) {
      bSignalSell = true;
      bSignalSell &= EvaluateTrigger0ValidationShort( symbol, period, time);
      }
   else {
      bSignalSell = !EvaluateTrigger0InvalidationShort( symbol, period, time);
      }

   Timestamp = bartime;
   if ( direction == OP_BUY) return( bSignalBuy);
   if ( direction == OP_SELL) return( bSignalSell);
   return( false);
   }

/*
    
*/
bool EvaluateTrigger0ValidationLong( string symbol, ENUM_TIMEFRAMES period, datetime time) {


   static datetime Timestamp = 0;
   static bool bSignal = false;
   static double valueX_1 = EMPTY_VALUE;
   static double valueY_1 = EMPTY_VALUE;

   if ( period > PERIOD_W1) {
      bSignal = false;
      return( false);
      }

   int shift = iBarShift( symbol, PERIOD_W1, time, true);
   if ( shift == -1) {
      bSignal = false;
      return( false);
      }

   datetime bartime = iTime( symbol, PERIOD_W1, shift);
   if ( bartime == Timestamp) {
      return( bSignal);
      }

   if ( ( bartime - Timestamp) >= PERIOD_W1) {
      valueX_1 = CCI( symbol, PERIOD_W1, shift+1);
      valueY_1 = level_0( symbol, PERIOD_W1, shift+1);
      }

   bSignal = false;
   double valueX = CCI( symbol, PERIOD_W1, shift);
   double valueY = level_0( symbol, PERIOD_W1, shift);

   if ( ( valueX != EMPTY_VALUE) && ( valueY != EMPTY_VALUE) && ( valueX_1 != EMPTY_VALUE) && ( valueY_1 != EMPTY_VALUE))
      bSignal = ( ( valueX > valueY) && ( valueX_1 < valueY_1));

   valueX_1 = valueX;
   valueY_1 = valueY;

   Timestamp = bartime;
   return( bSignal);
   }
/*
    
*/
bool EvaluateTrigger0ValidationShort( string symbol, ENUM_TIMEFRAMES period, datetime time) {


   static datetime Timestamp = 0;
   static bool bSignal = false;
   static double valueX_1 = EMPTY_VALUE;
   static double valueY_1 = EMPTY_VALUE;

   if ( period > PERIOD_W1) {
      bSignal = false;
      return( false);
      }

   int shift = iBarShift( symbol, PERIOD_W1, time, true);
   if ( shift == -1) {
      bSignal = false;
      return( false);
      }

   datetime bartime = iTime( symbol, PERIOD_W1, shift);
   if ( bartime == Timestamp) {
      return( bSignal);
      }

   if ( ( bartime - Timestamp) >= PERIOD_W1) {
      valueX_1 = CCI( symbol, PERIOD_W1, shift+1);
      valueY_1 = level_0( symbol, PERIOD_W1, shift+1);
      }

   bSignal = false;
   double valueX = CCI( symbol, PERIOD_W1, shift);
   double valueY = level_0( symbol, PERIOD_W1, shift);

   if ( ( valueX != EMPTY_VALUE) && ( valueY != EMPTY_VALUE) && ( valueX_1 != EMPTY_VALUE) && ( valueY_1 != EMPTY_VALUE))
      bSignal = ( ( valueX < valueY) && ( valueX_1 > valueY_1));

   valueX_1 = valueX;
   valueY_1 = valueY;

   Timestamp = bartime;
   return( bSignal);
   }
/*
    
*/
bool EvaluateTrigger0InvalidationLong( string symbol, ENUM_TIMEFRAMES period, datetime time) {


   static datetime Timestamp = 0;
   static bool bSignal = false;
   static double valueX_1 = EMPTY_VALUE;
   static double valueY_1 = EMPTY_VALUE;

   if ( period > PERIOD_W1) {
      bSignal = false;
      return( false);
      }

   int shift = iBarShift( symbol, PERIOD_W1, time, true);
   if ( shift == -1) {
      bSignal = false;
      return( false);
      }

   datetime bartime = iTime( symbol, PERIOD_W1, shift);
   if ( bartime == Timestamp) {
      return( bSignal);
      }

   if ( ( bartime - Timestamp) >= PERIOD_W1) {
      valueX_1 = CCI( symbol, PERIOD_W1, shift+1);
      valueY_1 = level_0( symbol, PERIOD_W1, shift+1);
      }

   bSignal = false;
   double valueX = CCI( symbol, PERIOD_W1, shift);
   double valueY = level_0( symbol, PERIOD_W1, shift);

   if ( ( valueX != EMPTY_VALUE) && ( valueY != EMPTY_VALUE) && ( valueX_1 != EMPTY_VALUE) && ( valueY_1 != EMPTY_VALUE))
      bSignal = ( ( valueX < valueY) && ( valueX_1 > valueY_1));

   valueX_1 = valueX;
   valueY_1 = valueY;

   Timestamp = bartime;
   return( bSignal);
   }
/*
    
*/
bool EvaluateTrigger0InvalidationShort( string symbol, ENUM_TIMEFRAMES period, datetime time) {


   static datetime Timestamp = 0;
   static bool bSignal = false;
   static double valueX_1 = EMPTY_VALUE;
   static double valueY_1 = EMPTY_VALUE;

   if ( period > PERIOD_W1) {
      bSignal = false;
      return( false);
      }

   int shift = iBarShift( symbol, PERIOD_W1, time, true);
   if ( shift == -1) {
      bSignal = false;
      return( false);
      }

   datetime bartime = iTime( symbol, PERIOD_W1, shift);
   if ( bartime == Timestamp) {
      return( bSignal);
      }

   if ( ( bartime - Timestamp) >= PERIOD_W1) {
      valueX_1 = CCI( symbol, PERIOD_W1, shift+1);
      valueY_1 = level_0( symbol, PERIOD_W1, shift+1);
      }

   bSignal = false;
   double valueX = CCI( symbol, PERIOD_W1, shift);
   double valueY = level_0( symbol, PERIOD_W1, shift);

   if ( ( valueX != EMPTY_VALUE) && ( valueY != EMPTY_VALUE) && ( valueX_1 != EMPTY_VALUE) && ( valueY_1 != EMPTY_VALUE))
      bSignal = ( ( valueX > valueY) && ( valueX_1 < valueY_1));

   valueX_1 = valueX;
   valueY_1 = valueY;

   Timestamp = bartime;
   return( bSignal);
   }
/*
    Daily CCI
*/
bool EvaluateBlock1( string symbol, ENUM_TIMEFRAMES period, datetime time, int direction) {

   static datetime Timestamp = 0;
   static bool bSignalBuy = false;
   static bool bSignalSell = false;

   if ( period > PERIOD_D1) {
      return( false);
      }

   datetime bartime = iTime( symbol, period, iBarShift( symbol, period, time, true));
   if ( bartime == Timestamp) {
      if ( direction == OP_BUY) return( bSignalBuy);
      if ( direction == OP_SELL) return( bSignalSell);
      }

   if ( !bSignalBuy) {
      bSignalBuy = true;
      bSignalBuy &= EvaluateTrigger1ValidationLong( symbol, period, time);
      }
   else {
      bSignalBuy = !EvaluateTrigger1InvalidationLong( symbol, period, time);
      }

   if ( !bSignalSell) {
      bSignalSell = true;
      bSignalSell &= EvaluateTrigger1ValidationShort( symbol, period, time);
      }
   else {
      bSignalSell = !EvaluateTrigger1InvalidationShort( symbol, period, time);
      }

   Timestamp = bartime;
   if ( direction == OP_BUY) return( bSignalBuy);
   if ( direction == OP_SELL) return( bSignalSell);
   return( false);
   }

/*
    
*/
bool EvaluateTrigger1ValidationLong( string symbol, ENUM_TIMEFRAMES period, datetime time) {


   static datetime Timestamp = 0;
   static bool bSignal = false;
   static double valueX_1 = EMPTY_VALUE;
   static double valueY_1 = EMPTY_VALUE;

   if ( period > PERIOD_D1) {
      bSignal = false;
      return( false);
      }

   int shift = iBarShift( symbol, PERIOD_D1, time, true);
   if ( shift == -1) {
      bSignal = false;
      return( false);
      }

   datetime bartime = iTime( symbol, PERIOD_D1, shift);
   if ( bartime == Timestamp) {
      return( bSignal);
      }

   if ( ( bartime - Timestamp) >= PERIOD_D1) {
      valueX_1 = CCI( symbol, PERIOD_D1, shift+1);
      valueY_1 = level_0( symbol, PERIOD_D1, shift+1);
      }

   bSignal = false;
   double valueX = CCI( symbol, PERIOD_D1, shift);
   double valueY = level_0( symbol, PERIOD_D1, shift);

   if ( ( valueX != EMPTY_VALUE) && ( valueY != EMPTY_VALUE) && ( valueX_1 != EMPTY_VALUE) && ( valueY_1 != EMPTY_VALUE))
      bSignal = ( ( valueX > valueY) && ( valueX_1 < valueY_1));

   valueX_1 = valueX;
   valueY_1 = valueY;

   Timestamp = bartime;
   return( bSignal);
   }
/*
    
*/
bool EvaluateTrigger1ValidationShort( string symbol, ENUM_TIMEFRAMES period, datetime time) {


   static datetime Timestamp = 0;
   static bool bSignal = false;
   static double valueX_1 = EMPTY_VALUE;
   static double valueY_1 = EMPTY_VALUE;

   if ( period > PERIOD_D1) {
      bSignal = false;
      return( false);
      }

   int shift = iBarShift( symbol, PERIOD_D1, time, true);
   if ( shift == -1) {
      bSignal = false;
      return( false);
      }

   datetime bartime = iTime( symbol, PERIOD_D1, shift);
   if ( bartime == Timestamp) {
      return( bSignal);
      }

   if ( ( bartime - Timestamp) >= PERIOD_D1) {
      valueX_1 = CCI( symbol, PERIOD_D1, shift+1);
      valueY_1 = level_0( symbol, PERIOD_D1, shift+1);
      }

   bSignal = false;
   double valueX = CCI( symbol, PERIOD_D1, shift);
   double valueY = level_0( symbol, PERIOD_D1, shift);

   if ( ( valueX != EMPTY_VALUE) && ( valueY != EMPTY_VALUE) && ( valueX_1 != EMPTY_VALUE) && ( valueY_1 != EMPTY_VALUE))
      bSignal = ( ( valueX < valueY) && ( valueX_1 > valueY_1));

   valueX_1 = valueX;
   valueY_1 = valueY;

   Timestamp = bartime;
   return( bSignal);
   }
/*
    
*/
bool EvaluateTrigger1InvalidationLong( string symbol, ENUM_TIMEFRAMES period, datetime time) {


   static datetime Timestamp = 0;
   static bool bSignal = false;
   static double valueX_1 = EMPTY_VALUE;
   static double valueY_1 = EMPTY_VALUE;

   if ( period > PERIOD_D1) {
      bSignal = false;
      return( false);
      }

   int shift = iBarShift( symbol, PERIOD_D1, time, true);
   if ( shift == -1) {
      bSignal = false;
      return( false);
      }

   datetime bartime = iTime( symbol, PERIOD_D1, shift);
   if ( bartime == Timestamp) {
      return( bSignal);
      }

   if ( ( bartime - Timestamp) >= PERIOD_D1) {
      valueX_1 = CCI( symbol, PERIOD_D1, shift+1);
      valueY_1 = level_0( symbol, PERIOD_D1, shift+1);
      }

   bSignal = false;
   double valueX = CCI( symbol, PERIOD_D1, shift);
   double valueY = level_0( symbol, PERIOD_D1, shift);

   if ( ( valueX != EMPTY_VALUE) && ( valueY != EMPTY_VALUE) && ( valueX_1 != EMPTY_VALUE) && ( valueY_1 != EMPTY_VALUE))
      bSignal = ( ( valueX < valueY) && ( valueX_1 > valueY_1));

   valueX_1 = valueX;
   valueY_1 = valueY;

   Timestamp = bartime;
   return( bSignal);
   }
/*
    
*/
bool EvaluateTrigger1InvalidationShort( string symbol, ENUM_TIMEFRAMES period, datetime time) {


   static datetime Timestamp = 0;
   static bool bSignal = false;
   static double valueX_1 = EMPTY_VALUE;
   static double valueY_1 = EMPTY_VALUE;

   if ( period > PERIOD_D1) {
      bSignal = false;
      return( false);
      }

   int shift = iBarShift( symbol, PERIOD_D1, time, true);
   if ( shift == -1) {
      bSignal = false;
      return( false);
      }

   datetime bartime = iTime( symbol, PERIOD_D1, shift);
   if ( bartime == Timestamp) {
      return( bSignal);
      }

   if ( ( bartime - Timestamp) >= PERIOD_D1) {
      valueX_1 = CCI( symbol, PERIOD_D1, shift+1);
      valueY_1 = level_0( symbol, PERIOD_D1, shift+1);
      }

   bSignal = false;
   double valueX = CCI( symbol, PERIOD_D1, shift);
   double valueY = level_0( symbol, PERIOD_D1, shift);

   if ( ( valueX != EMPTY_VALUE) && ( valueY != EMPTY_VALUE) && ( valueX_1 != EMPTY_VALUE) && ( valueY_1 != EMPTY_VALUE))
      bSignal = ( ( valueX > valueY) && ( valueX_1 < valueY_1));

   valueX_1 = valueX;
   valueY_1 = valueY;

   Timestamp = bartime;
   return( bSignal);
   }
/*
    H4 CCI
*/
bool EvaluateBlock2( string symbol, ENUM_TIMEFRAMES period, datetime time, int direction) {

   static datetime Timestamp = 0;
   static bool bSignalBuy = false;
   static bool bSignalSell = false;

   if ( period > PERIOD_H4) {
      return( false);
      }

   datetime bartime = iTime( symbol, period, iBarShift( symbol, period, time, true));
   if ( bartime == Timestamp) {
      if ( direction == OP_BUY) return( bSignalBuy);
      if ( direction == OP_SELL) return( bSignalSell);
      }

   if ( !bSignalBuy) {
      bSignalBuy = true;
      bSignalBuy &= EvaluateTrigger2ValidationLong( symbol, period, time);
      }
   else {
      bSignalBuy = !EvaluateTrigger2InvalidationLong( symbol, period, time);
      }

   if ( !bSignalSell) {
      bSignalSell = true;
      bSignalSell &= EvaluateTrigger2ValidationShort( symbol, period, time);
      }
   else {
      bSignalSell = !EvaluateTrigger2InvalidationShort( symbol, period, time);
      }

   Timestamp = bartime;
   if ( direction == OP_BUY) return( bSignalBuy);
   if ( direction == OP_SELL) return( bSignalSell);
   return( false);
   }

/*
    
*/
bool EvaluateTrigger2ValidationLong( string symbol, ENUM_TIMEFRAMES period, datetime time) {


   static datetime Timestamp = 0;
   static bool bSignal = false;
   static double valueX_1 = EMPTY_VALUE;
   static double valueY_1 = EMPTY_VALUE;

   if ( period > PERIOD_H4) {
      bSignal = false;
      return( false);
      }

   int shift = iBarShift( symbol, PERIOD_H4, time, true);
   if ( shift == -1) {
      bSignal = false;
      return( false);
      }

   datetime bartime = iTime( symbol, PERIOD_H4, shift);
   if ( bartime == Timestamp) {
      return( bSignal);
      }

   if ( ( bartime - Timestamp) >= PERIOD_H4) {
      valueX_1 = CCI( symbol, PERIOD_H4, shift+1);
      valueY_1 = level_0( symbol, PERIOD_H4, shift+1);
      }

   bSignal = false;
   double valueX = CCI( symbol, PERIOD_H4, shift);
   double valueY = level_0( symbol, PERIOD_H4, shift);

   if ( ( valueX != EMPTY_VALUE) && ( valueY != EMPTY_VALUE) && ( valueX_1 != EMPTY_VALUE) && ( valueY_1 != EMPTY_VALUE))
      bSignal = ( ( valueX > valueY) && ( valueX_1 < valueY_1));

   valueX_1 = valueX;
   valueY_1 = valueY;

   Timestamp = bartime;
   return( bSignal);
   }
/*
    
*/
bool EvaluateTrigger2ValidationShort( string symbol, ENUM_TIMEFRAMES period, datetime time) {


   static datetime Timestamp = 0;
   static bool bSignal = false;
   static double valueX_1 = EMPTY_VALUE;
   static double valueY_1 = EMPTY_VALUE;

   if ( period > PERIOD_H4) {
      bSignal = false;
      return( false);
      }

   int shift = iBarShift( symbol, PERIOD_H4, time, true);
   if ( shift == -1) {
      bSignal = false;
      return( false);
      }

   datetime bartime = iTime( symbol, PERIOD_H4, shift);
   if ( bartime == Timestamp) {
      return( bSignal);
      }

   if ( ( bartime - Timestamp) >= PERIOD_H4) {
      valueX_1 = CCI( symbol, PERIOD_H4, shift+1);
      valueY_1 = level_0( symbol, PERIOD_H4, shift+1);
      }

   bSignal = false;
   double valueX = CCI( symbol, PERIOD_H4, shift);
   double valueY = level_0( symbol, PERIOD_H4, shift);

   if ( ( valueX != EMPTY_VALUE) && ( valueY != EMPTY_VALUE) && ( valueX_1 != EMPTY_VALUE) && ( valueY_1 != EMPTY_VALUE))
      bSignal = ( ( valueX < valueY) && ( valueX_1 > valueY_1));

   valueX_1 = valueX;
   valueY_1 = valueY;

   Timestamp = bartime;
   return( bSignal);
   }
/*
    
*/
bool EvaluateTrigger2InvalidationLong( string symbol, ENUM_TIMEFRAMES period, datetime time) {


   static datetime Timestamp = 0;
   static bool bSignal = false;
   static double valueX_1 = EMPTY_VALUE;
   static double valueY_1 = EMPTY_VALUE;

   if ( period > PERIOD_H4) {
      bSignal = false;
      return( false);
      }

   int shift = iBarShift( symbol, PERIOD_H4, time, true);
   if ( shift == -1) {
      bSignal = false;
      return( false);
      }

   datetime bartime = iTime( symbol, PERIOD_H4, shift);
   if ( bartime == Timestamp) {
      return( bSignal);
      }

   if ( ( bartime - Timestamp) >= PERIOD_H4) {
      valueX_1 = CCI( symbol, PERIOD_H4, shift+1);
      valueY_1 = level_0( symbol, PERIOD_H4, shift+1);
      }

   bSignal = false;
   double valueX = CCI( symbol, PERIOD_H4, shift);
   double valueY = level_0( symbol, PERIOD_H4, shift);

   if ( ( valueX != EMPTY_VALUE) && ( valueY != EMPTY_VALUE) && ( valueX_1 != EMPTY_VALUE) && ( valueY_1 != EMPTY_VALUE))
      bSignal = ( ( valueX < valueY) && ( valueX_1 > valueY_1));

   valueX_1 = valueX;
   valueY_1 = valueY;

   Timestamp = bartime;
   return( bSignal);
   }
/*
    
*/
bool EvaluateTrigger2InvalidationShort( string symbol, ENUM_TIMEFRAMES period, datetime time) {


   static datetime Timestamp = 0;
   static bool bSignal = false;
   static double valueX_1 = EMPTY_VALUE;
   static double valueY_1 = EMPTY_VALUE;

   if ( period > PERIOD_H4) {
      bSignal = false;
      return( false);
      }

   int shift = iBarShift( symbol, PERIOD_H4, time, true);
   if ( shift == -1) {
      bSignal = false;
      return( false);
      }

   datetime bartime = iTime( symbol, PERIOD_H4, shift);
   if ( bartime == Timestamp) {
      return( bSignal);
      }

   if ( ( bartime - Timestamp) >= PERIOD_H4) {
      valueX_1 = CCI( symbol, PERIOD_H4, shift+1);
      valueY_1 = level_0( symbol, PERIOD_H4, shift+1);
      }

   bSignal = false;
   double valueX = CCI( symbol, PERIOD_H4, shift);
   double valueY = level_0( symbol, PERIOD_H4, shift);

   if ( ( valueX != EMPTY_VALUE) && ( valueY != EMPTY_VALUE) && ( valueX_1 != EMPTY_VALUE) && ( valueY_1 != EMPTY_VALUE))
      bSignal = ( ( valueX > valueY) && ( valueX_1 < valueY_1));

   valueX_1 = valueX;
   valueY_1 = valueY;

   Timestamp = bartime;
   return( bSignal);
   }
/*
    
*/
bool EvaluateTriggerValidationLong( string symbol, ENUM_TIMEFRAMES period, datetime time) {


   static datetime Timestamp = 0;
   static bool bSignal = false;
   static double valueX_1 = EMPTY_VALUE;
   static double valueY_1 = EMPTY_VALUE;

   if ( period > PERIOD_H1) {
      bSignal = false;
      return( false);
      }

   int shift = iBarShift( symbol, PERIOD_H1, time, true);
   if ( shift == -1) {
      bSignal = false;
      return( false);
      }

   datetime bartime = iTime( symbol, PERIOD_H1, shift);
   if ( bartime == Timestamp) {
      return( bSignal);
      }

   if ( ( bartime - Timestamp) >= PERIOD_H1) {
      valueX_1 = CCI( symbol, PERIOD_H1, shift+1);
      valueY_1 = level_0( symbol, PERIOD_H1, shift+1);
      }

   bSignal = false;
   double valueX = CCI( symbol, PERIOD_H1, shift);
   double valueY = level_0( symbol, PERIOD_H1, shift);

   if ( ( valueX != EMPTY_VALUE) && ( valueY != EMPTY_VALUE) && ( valueX_1 != EMPTY_VALUE) && ( valueY_1 != EMPTY_VALUE))
      bSignal = ( ( valueX > valueY) && ( valueX_1 < valueY_1));

   valueX_1 = valueX;
   valueY_1 = valueY;

   Timestamp = bartime;
   return( bSignal);
   }
/*
    
*/
bool EvaluateTriggerValidationShort( string symbol, ENUM_TIMEFRAMES period, datetime time) {


   static datetime Timestamp = 0;
   static bool bSignal = false;
   static double valueX_1 = EMPTY_VALUE;
   static double valueY_1 = EMPTY_VALUE;

   if ( period > PERIOD_H1) {
      bSignal = false;
      return( false);
      }

   int shift = iBarShift( symbol, PERIOD_H1, time, true);
   if ( shift == -1) {
      bSignal = false;
      return( false);
      }

   datetime bartime = iTime( symbol, PERIOD_H1, shift);
   if ( bartime == Timestamp) {
      return( bSignal);
      }

   if ( ( bartime - Timestamp) >= PERIOD_H1) {
      valueX_1 = CCI( symbol, PERIOD_H1, shift+1);
      valueY_1 = level_0( symbol, PERIOD_H1, shift+1);
      }

   bSignal = false;
   double valueX = CCI( symbol, PERIOD_H1, shift);
   double valueY = level_0( symbol, PERIOD_H1, shift);

   if ( ( valueX != EMPTY_VALUE) && ( valueY != EMPTY_VALUE) && ( valueX_1 != EMPTY_VALUE) && ( valueY_1 != EMPTY_VALUE))
      bSignal = ( ( valueX < valueY) && ( valueX_1 > valueY_1));

   valueX_1 = valueX;
   valueY_1 = valueY;

   Timestamp = bartime;
   return( bSignal);
   }
