//+------------------------------------------------------------------+
//|                                                mq4bPrototype.mq4 |
//|                                         Copyright 2018, stivborg |
//|                                              http://www.mql4.com |
//+------------------------------------------------------------------+
#property copyright "Copyright 2018, stivborg"
#property link      "http://www.mql4.com"
#property version   "1.00"
#property strict
#property indicator_chart_window
#property indicator_buffers 2
#property indicator_plots   2
//--- plot Down
#property indicator_label1  "Down"
#property indicator_type1   DRAW_ARROW
#property indicator_color1  clrOrangeRed
#property indicator_style1  STYLE_SOLID
#property indicator_width1  5
//--- plot Up
#property indicator_label2  "Up"
#property indicator_type2   DRAW_ARROW
#property indicator_color2  clrDodgerBlue
#property indicator_style2  STYLE_SOLID
#property indicator_width2  5
//--- indicator buffers
double         DownBuffer[];
double         UpBuffer[];

#include "buffers.mqh"
#include "evaluation.mqh"



bool bProcessingHistory;

  
void WhenHistoryProcessFinished( int zaba) {
   }
  
  
void WhenSignal( string symbol, ENUM_TIMEFRAMES period, datetime time, int direction) {

   if ( symbol == Symbol()) {
      int shift = iBarShift( symbol, Period(), time);
      if ( shift != -1) {
         if ( direction == OP_BUY) UpBuffer[ shift] = iLow( symbol, Period(), shift);
         if ( direction == OP_SELL) DownBuffer[ shift] = iHigh( symbol, Period(), shift);
         }
      }
   }
  
typedef void ( *TFinishedCallback)( int zaba);
typedef void ( *TEvaluateCallback)( string symbol, ENUM_TIMEFRAMES period, datetime time, bool &long_signal, bool &short_signal);
typedef void ( *TSignalCallback)( string symbol, ENUM_TIMEFRAMES period, datetime time, int direction);


#import "HistoryProcess.ex4"
   void OnTimer();
   void Init();
   void Deinit();
   void Process();
   void EvaluationSetup();
   void AddSymbol ( string symbol);
   void AddTimeframe ( ENUM_TIMEFRAMES timeframe);
   void SetRequiredBars ( int bars);
   void SetEvaluateCallback ( TEvaluateCallback callback);
   void SetSignalCallback ( TSignalCallback callback);
   void SetFinishedCallback ( TFinishedCallback callback, int k);
#import


//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int OnInit()
  {
//--- indicator buffers mapping
   SetIndexBuffer(0,DownBuffer);
   SetIndexBuffer(1,UpBuffer);
//--- setting a code from the Wingdings charset as the property of PLOT_ARROW
   PlotIndexSetInteger(0,PLOT_ARROW,159);
   PlotIndexSetInteger(1,PLOT_ARROW,159);
   
   IndicatorDigits( _Digits);

   HistoryProcess::Init();   
   HistoryProcess::AddSymbol( Symbol());
   for ( int tt = 0; tt < NEVALTF; tt++)
      HistoryProcess::AddTimeframe( EvaluationTimeframes[ tt]);
   HistoryProcess::SetRequiredBars( 10000);
   HistoryProcess::SetFinishedCallback( WhenHistoryProcessFinished, 7);
   HistoryProcess::SetEvaluateCallback( EvaluateProgram);
   HistoryProcess::SetSignalCallback( WhenSignal);
   HistoryProcess::Process();
   bProcessingHistory = true;
   EventSetMillisecondTimer( 100); 
   
//---
   return(INIT_SUCCEEDED);
  }
  

  
void OnDeinit(const int reason) {
   if (bProcessingHistory) {
      EventKillTimer();
      HistoryProcess::Deinit();   
      bProcessingHistory = false;
      }
   }  
  
void OnTimer() {
   HistoryProcess::OnTimer();              
   }
  
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int OnCalculate(const int rates_total,
                const int prev_calculated,
                const datetime &time[],
                const double &open[],
                const double &high[],
                const double &low[],
                const double &close[],
                const long &tick_volume[],
                const long &volume[],
                const int &spread[])
  {
//---
   
   
//--- return value of prev_calculated for next call
   return(rates_total);
  }
